ArrayNode
Date: 2016-12-04

com.fasterxml.jackson.databind.node

## Class ArrayNode

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializable.Base
  - - com.fasterxml.jackson.databind.JsonNode
    - - com.fasterxml.jackson.databind.node.BaseJsonNode
      - - com.fasterxml.jackson.databind.node.ContainerNode<ArrayNode>
        - - com.fasterxml.jackson.databind.node.ArrayNode

- All Implemented Interfaces:
    com.fasterxml.jackson.core.TreeNode, JsonSerializable, JsonNodeCreator, java.lang.Iterable<JsonNode>

      public class ArrayNode
      extends ContainerNode<ArrayNode>

  Node class that represents Arrays mapped from JSON content.

  Note: class was `final` temporarily for Jackson 2.2.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

      `JsonSerializable.Base`

  - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.node.ContainerNode

      `_nodeFactory`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ArrayNode(JsonNodeFactory nf)`
    `ArrayNode(JsonNodeFactory nf, int capacity)`
    `ArrayNode(JsonNodeFactory nf, java.util.List<JsonNode> children)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected ArrayNode` | `_add(JsonNode node)`
    `protected JsonNode` | `_at(com.fasterxml.jackson.core.JsonPointer ptr)`
    `protected boolean` | `_childrenEqual(ArrayNode other)`
    `protected ArrayNode` | `_insert(int index, JsonNode node)`
    `ArrayNode` | `add(java.math.BigDecimal v)` Method for adding specified number at the end of this array.
    `ArrayNode` | `add(boolean v)` Method for adding specified boolean value at the end of this array.
    `ArrayNode` | `add(java.lang.Boolean value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `add(byte[] v)` Method for adding specified binary value at the end of this array (note: when serializing as JSON, will be output Base64 encoded)
    `ArrayNode` | `add(double v)` Method for adding specified number at the end of this array.
    `ArrayNode` | `add(java.lang.Double value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `add(float v)` Method for adding specified number at the end of this array.
    `ArrayNode` | `add(java.lang.Float value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `add(int v)` Method for adding specified number at the end of this array.
    `ArrayNode` | `add(java.lang.Integer value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `add(JsonNode value)` Method for adding specified node at the end of this array.
    `ArrayNode` | `add(long v)` Method for adding specified number at the end of this array.
    `ArrayNode` | `add(java.lang.Long value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `add(java.lang.String v)` Method for adding specified String value at the end of this array.
    `ArrayNode` | `addAll(ArrayNode other)` Method for adding all child nodes of given Array, appending to child nodes this array contains
    `ArrayNode` | `addAll(java.util.Collection<? extends JsonNode> nodes)` Method for adding given nodes as child nodes of this array node.
    `ArrayNode` | `addArray()` Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.
    `ArrayNode` | `addNull()` Method that will add a null value at the end of this array node.
    `ObjectNode` | `addObject()` Method that will construct an ObjectNode and add it at the end of this array node.
    `ArrayNode` | `addPOJO(java.lang.Object value)` Method that will construct a POJONode and add it at the end of this array node.
    `ArrayNode` | `addRawValue(RawValue raw)`
    `com.fasterxml.jackson.core.JsonToken` | `asToken()` Method that can be used for efficient type detection when using stream abstraction for traversing nodes.
    `ArrayNode` | `deepCopy()` Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children.
    `java.util.Iterator<JsonNode>` | `elements()` Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node.
    `boolean` | `equals(java.util.Comparator<JsonNode> comparator, JsonNode o)` Entry method for invoking customizable comparison, using passed-in `Comparator` object.
    `boolean` | `equals(java.lang.Object o)` Equality for node objects is defined as full (deep) value equality.
    `ObjectNode` | `findParent(java.lang.String fieldName)` Method for finding a JSON Object that contains specified field, within this node or its descendants.
    `java.util.List<JsonNode>` | `findParents(java.lang.String fieldName, java.util.List<JsonNode> foundSoFar)`
    `JsonNode` | `findValue(java.lang.String fieldName)` Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has.
    `java.util.List<JsonNode>` | `findValues(java.lang.String fieldName, java.util.List<JsonNode> foundSoFar)`
    `java.util.List<java.lang.String>` | `findValuesAsText(java.lang.String fieldName, java.util.List<java.lang.String> foundSoFar)`
    `JsonNode` | `get(int index)` Method for accessing value of the specified element of an array node.
    `JsonNode` | `get(java.lang.String fieldName)` Method for accessing value of the specified field of an object node.
    `JsonNodeType` | `getNodeType()` Return the type of this node
    `int` | `hashCode()`
    `ArrayNode` | `insert(int index, java.math.BigDecimal v)` Method that will insert specified numeric value at specified position in this array.
    `ArrayNode` | `insert(int index, boolean v)` Method that will insert specified String at specified position in this array.
    `ArrayNode` | `insert(int index, java.lang.Boolean value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `insert(int index, byte[] v)` Method that will insert specified binary value at specified position in this array (note: when written as JSON, will be Base64 encoded)
    `ArrayNode` | `insert(int index, double v)` Method that will insert specified numeric value at specified position in this array.
    `ArrayNode` | `insert(int index, java.lang.Double value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `insert(int index, float v)` Method that will insert specified numeric value at specified position in this array.
    `ArrayNode` | `insert(int index, java.lang.Float value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `insert(int index, int v)` Method that will insert specified numeric value at specified position in this array.
    `ArrayNode` | `insert(int index, java.lang.Integer value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `insert(int index, JsonNode value)` Method for inserting specified child node as an element of this Array.
    `ArrayNode` | `insert(int index, long v)` Method that will insert specified numeric value at specified position in this array.
    `ArrayNode` | `insert(int index, java.lang.Long value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
    `ArrayNode` | `insert(int index, java.lang.String v)` Method that will insert specified String at specified position in this array.
    `ArrayNode` | `insertArray(int index)` Method for creating an array node, inserting it at the specified point in the array, and returning the newly created array (note: NOT 'this' array)
    `ArrayNode` | `insertNull(int index)` Method that will insert a null value at specified position in this array.
    `ObjectNode` | `insertObject(int index)` Method for creating an `ObjectNode`, appending it at the end of this array, and returning the newly created node (note: NOT 'this' array)
    `ArrayNode` | `insertPOJO(int index, java.lang.Object value)` Method that will construct a POJONode and insert it at specified position in this array.
    `boolean` | `isEmpty(SerializerProvider serializers)` Method that may be called on instance to determine if it is considered "empty" for purposes of serialization filtering or not.
    `JsonNode` | `path(int index)` This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
    `JsonNode` | `path(java.lang.String fieldName)` This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
    `JsonNode` | `remove(int index)` Method for removing an entry from this ArrayNode.
    `ArrayNode` | `removeAll()` Method for removing all elements of this array, leaving the array empty.
    `void` | `serialize(com.fasterxml.jackson.core.JsonGenerator f, SerializerProvider provider)` Method called to serialize node instances using given generator.
    `void` | `serializeWithType(com.fasterxml.jackson.core.JsonGenerator jg, SerializerProvider provider, TypeSerializer typeSer)` Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
    `JsonNode` | `set(int index, JsonNode value)` Method that will set specified field, replacing old value, if any.
    `int` | `size()`
    `java.lang.String` | `toString()` Method that will produce developer-readable representation of the node; which may or may not be as valid JSON.

    - ### Methods inherited from class com.fasterxml.jackson.databind.node.ContainerNode

      `arrayNode, arrayNode, asText, binaryNode, binaryNode, booleanNode, nullNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, objectNode, pojoNode, rawValueNode, textNode`

    - ### Methods inherited from class com.fasterxml.jackson.databind.node.BaseJsonNode

      `findPath, numberType, traverse, traverse`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonNode

      `asBoolean, asBoolean, asDouble, asDouble, asInt, asInt, asLong, asLong, asText, at, at, bigIntegerValue, binaryValue, booleanValue, canConvertToInt, canConvertToLong, decimalValue, doubleValue, fieldNames, fields, findParents, findValues, findValuesAsText, floatValue, has, has, hasNonNull, hasNonNull, intValue, isArray, isBigDecimal, isBigInteger, isBinary, isBoolean, isContainerNode, isDouble, isFloat, isFloatingPointNumber, isInt, isIntegralNumber, isLong, isMissingNode, isNull, isNumber, isObject, isPojo, isShort, isTextual, isValueNode, iterator, longValue, numberValue, shortValue, textValue, with, withArray`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ArrayNode

          public ArrayNode(JsonNodeFactory nf)

    - #### ArrayNode

          public ArrayNode(JsonNodeFactory nf,
                   int capacity)

      Since:
        2.8

    - #### ArrayNode

          public ArrayNode(JsonNodeFactory nf,
                   java.util.List<JsonNode> children)

      Since:
        2.7

  - ### Method Detail

    - #### _at

          protected JsonNode _at(com.fasterxml.jackson.core.JsonPointer ptr)

      Specified by:
        `_at` in class `JsonNode`

    - #### deepCopy

          public ArrayNode deepCopy()

      Description copied from class: `JsonNode`
      Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children. This means it can either make a copy of this node (and all mutable children and grand children nodes), or node itself if it is immutable.

      Note: return type is guaranteed to have same type as the node method is called on; which is why method is declared with local generic type.

      Specified by:
        `deepCopy` in class `JsonNode`
      Returns:
        Node that is either a copy of this node (and all non-leaf children); or, for immutable leaf nodes, node itself.

    - #### isEmpty

          public boolean isEmpty(SerializerProvider serializers)

      Description copied from class: `JsonSerializable.Base`
      Method that may be called on instance to determine if it is considered "empty" for purposes of serialization filtering or not.
      Overrides:
        `isEmpty` in class `JsonSerializable.Base`

    - #### getNodeType

          public JsonNodeType getNodeType()

      Description copied from class: `JsonNode`
      Return the type of this node
      Specified by:
        `getNodeType` in class `JsonNode`
      Returns:
        the node type as a `JsonNodeType` enum value

    - #### asToken

          public com.fasterxml.jackson.core.JsonToken asToken()

      Description copied from class: `BaseJsonNode`
      Method that can be used for efficient type detection when using stream abstraction for traversing nodes. Will return the first `JsonToken` that equivalent stream event would produce (for most nodes there is just one token but for structured/container types multiple)
      Specified by:
        `asToken` in interface `com.fasterxml.jackson.core.TreeNode`
      Specified by:
        `asToken` in class `ContainerNode<ArrayNode>`

    - #### size

          public int size()

      Specified by:
        `size` in interface `com.fasterxml.jackson.core.TreeNode`
      Specified by:
        `size` in class `ContainerNode<ArrayNode>`

    - #### elements

          public java.util.Iterator<JsonNode> elements()

      Description copied from class: `JsonNode`
      Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node. In case of Object node, field names (keys) are not included, only values. For other types of nodes, returns empty iterator.
      Overrides:
        `elements` in class `JsonNode`

    - #### get

          public JsonNode get(int index)

      Description copied from class: `JsonNode`
      Method for accessing value of the specified element of an array node. For other nodes, null is always returned.

      For array nodes, index specifies exact location within array and allows for efficient iteration over child elements (underlying storage is guaranteed to be efficiently indexable, i.e. has random-access to elements). If index is less than 0, or equal-or-greater than `node.size()`, null is returned; no exception is thrown for any index.

      NOTE: if the element value has been explicitly set as `null` (which is different from removal!), a `NullNode` will be returned, not null.

      Specified by:
        `get` in interface `com.fasterxml.jackson.core.TreeNode`
      Specified by:
        `get` in class `ContainerNode<ArrayNode>`
      Returns:
        Node that represent value of the specified element, if this node is an array and has specified element. Null otherwise.

    - #### get

          public JsonNode get(java.lang.String fieldName)

      Description copied from class: `JsonNode`
      Method for accessing value of the specified field of an object node. If this node is not an object (or it does not have a value for specified field name), or if there is no field with such name, null is returned.

      NOTE: if the property value has been explicitly set as `null` (which is different from removal!), a `NullNode` will be returned, not null.

      Specified by:
        `get` in interface `com.fasterxml.jackson.core.TreeNode`
      Specified by:
        `get` in class `ContainerNode<ArrayNode>`
      Returns:
        Node that represent value of the specified field, if this node is an object and has value for the specified field. Null otherwise.

    - #### path

          public JsonNode path(java.lang.String fieldName)

      Description copied from class: `JsonNode`
      This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.
      Specified by:
        `path` in interface `com.fasterxml.jackson.core.TreeNode`
      Specified by:
        `path` in class `JsonNode`

    - #### path

          public JsonNode path(int index)

      Description copied from class: `JsonNode`
      This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.
      Specified by:
        `path` in interface `com.fasterxml.jackson.core.TreeNode`
      Specified by:
        `path` in class `JsonNode`

    - #### equals

          public boolean equals(java.util.Comparator<JsonNode> comparator,
                       JsonNode o)

      Description copied from class: `JsonNode`
      Entry method for invoking customizable comparison, using passed-in `Comparator` object. Nodes will handle traversal of structured types (arrays, objects), but defer to comparator for scalar value comparisons. If a "natural" `Comparator` is passed -- one that simply calls `equals()` on one of arguments, passing the other -- implementation is the same as directly calling `equals()` on node.

      Default implementation simply delegates to passed in `comparator`, with `this` as the first argument, and `other` as the second argument.

      Overrides:
        `equals` in class `JsonNode`
      Parameters:
        `comparator` - Object called to compare two scalar `JsonNode` instances, and return either 0 (are equals) or non-zero (not equal)

    - #### serialize

          public void serialize(com.fasterxml.jackson.core.JsonGenerator f,
                       SerializerProvider provider)
                         throws java.io.IOException

      Description copied from class: `BaseJsonNode`
      Method called to serialize node instances using given generator.
      Specified by:
        `serialize` in interface `JsonSerializable`
      Specified by:
        `serialize` in class `BaseJsonNode`
      Throws:
        `java.io.IOException`

    - #### serializeWithType

          public void serializeWithType(com.fasterxml.jackson.core.JsonGenerator jg,
                               SerializerProvider provider,
                               TypeSerializer typeSer)
                                 throws java.io.IOException

      Description copied from class: `BaseJsonNode`
      Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
      Specified by:
        `serializeWithType` in interface `JsonSerializable`
      Specified by:
        `serializeWithType` in class `BaseJsonNode`
      Throws:
        `java.io.IOException`

    - #### findValue

          public JsonNode findValue(java.lang.String fieldName)

      Description copied from class: `JsonNode`
      Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has. If no matching field is found in this node or its descendants, returns null.
      Specified by:
        `findValue` in class `JsonNode`
      Parameters:
        `fieldName` - Name of field to look for
      Returns:
        Value of first matching node found, if any; null if none

    - #### findValues

          public java.util.List<JsonNode> findValues(java.lang.String fieldName,
                                            java.util.List<JsonNode> foundSoFar)

      Specified by:
        `findValues` in class `JsonNode`

    - #### findValuesAsText

          public java.util.List<java.lang.String> findValuesAsText(java.lang.String fieldName,
                                                          java.util.List<java.lang.String> foundSoFar)

      Specified by:
        `findValuesAsText` in class `JsonNode`

    - #### findParent

          public ObjectNode findParent(java.lang.String fieldName)

      Description copied from class: `JsonNode`
      Method for finding a JSON Object that contains specified field, within this node or its descendants. If no matching field is found in this node or its descendants, returns null.
      Specified by:
        `findParent` in class `JsonNode`
      Parameters:
        `fieldName` - Name of field to look for
      Returns:
        Value of first matching node found, if any; null if none

    - #### findParents

          public java.util.List<JsonNode> findParents(java.lang.String fieldName,
                                             java.util.List<JsonNode> foundSoFar)

      Specified by:
        `findParents` in class `JsonNode`

    - #### set

          public JsonNode set(int index,
                     JsonNode value)

      Method that will set specified field, replacing old value, if any.
      Parameters:
        `value` - to set field to; if null, will be converted to a `NullNode` first (to remove field entry, call `remove(int)` instead)
      Returns:
        Old value of the field, if any; null if there was no old value.

    - #### add

          public ArrayNode add(JsonNode value)

      Method for adding specified node at the end of this array.
      Returns:
        This node, to allow chaining

    - #### addAll

          public ArrayNode addAll(ArrayNode other)

      Method for adding all child nodes of given Array, appending to child nodes this array contains
      Parameters:
        `other` - Array to add contents from
      Returns:
        This node (to allow chaining)

    - #### addAll

          public ArrayNode addAll(java.util.Collection<? extends JsonNode> nodes)

      Method for adding given nodes as child nodes of this array node.
      Parameters:
        `nodes` - Nodes to add
      Returns:
        This node (to allow chaining)

    - #### insert

          public ArrayNode insert(int index,
                         JsonNode value)

      Method for inserting specified child node as an element of this Array. If index is 0 or less, it will be inserted as the first element; if >= size(), appended at the end, and otherwise inserted before existing element in specified index. No exceptions are thrown for any index.
      Returns:
        This node (to allow chaining)

    - #### remove

          public JsonNode remove(int index)

      Method for removing an entry from this ArrayNode. Will return value of the entry at specified index, if entry existed; null if not.
      Returns:
        Node removed, if any; null if none

    - #### removeAll

          public ArrayNode removeAll()

      Method for removing all elements of this array, leaving the array empty.
      Specified by:
        `removeAll` in class `ContainerNode<ArrayNode>`
      Returns:
        This node (to allow chaining)

    - #### addArray

          public ArrayNode addArray()

      Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.
      Returns:
        Newly constructed ArrayNode

    - #### addObject

          public ObjectNode addObject()

      Method that will construct an ObjectNode and add it at the end of this array node.
      Returns:
        Newly constructed ObjectNode

    - #### addPOJO

          public ArrayNode addPOJO(java.lang.Object value)

      Method that will construct a POJONode and add it at the end of this array node.
      Returns:
        This array node, to allow chaining

    - #### addRawValue

          public ArrayNode addRawValue(RawValue raw)

      Returns:
        This array node, to allow chaining
      Since:
        2.6

    - #### addNull

          public ArrayNode addNull()

      Method that will add a null value at the end of this array node.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(int v)

      Method for adding specified number at the end of this array.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(java.lang.Integer value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(long v)

      Method for adding specified number at the end of this array.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(java.lang.Long value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(float v)

      Method for adding specified number at the end of this array.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(java.lang.Float value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(double v)

      Method for adding specified number at the end of this array.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(java.lang.Double value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(java.math.BigDecimal v)

      Method for adding specified number at the end of this array.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(java.lang.String v)

      Method for adding specified String value at the end of this array.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(boolean v)

      Method for adding specified boolean value at the end of this array.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(java.lang.Boolean value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### add

          public ArrayNode add(byte[] v)

      Method for adding specified binary value at the end of this array (note: when serializing as JSON, will be output Base64 encoded)
      Returns:
        This array node, to allow chaining

    - #### insertArray

          public ArrayNode insertArray(int index)

      Method for creating an array node, inserting it at the specified point in the array, and returning the newly created array (note: NOT 'this' array)

    - #### insertObject

          public ObjectNode insertObject(int index)

      Method for creating an `ObjectNode`, appending it at the end of this array, and returning the newly created node (note: NOT 'this' array)
      Returns:
        Newly constructed ObjectNode

    - #### insertPOJO

          public ArrayNode insertPOJO(int index,
                             java.lang.Object value)

      Method that will construct a POJONode and insert it at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insertNull

          public ArrayNode insertNull(int index)

      Method that will insert a null value at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         int v)

      Method that will insert specified numeric value at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         java.lang.Integer value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         long v)

      Method that will insert specified numeric value at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         java.lang.Long value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         float v)

      Method that will insert specified numeric value at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         java.lang.Float value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         double v)

      Method that will insert specified numeric value at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         java.lang.Double value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         java.math.BigDecimal v)

      Method that will insert specified numeric value at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         java.lang.String v)

      Method that will insert specified String at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         boolean v)

      Method that will insert specified String at specified position in this array.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         java.lang.Boolean value)

      Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
      Returns:
        This array node, to allow chaining

    - #### insert

          public ArrayNode insert(int index,
                         byte[] v)

      Method that will insert specified binary value at specified position in this array (note: when written as JSON, will be Base64 encoded)
      Returns:
        This array node, to allow chaining

    - #### equals

          public boolean equals(java.lang.Object o)

      Description copied from class: `JsonNode`
      Equality for node objects is defined as full (deep) value equality. This means that it is possible to compare complete JSON trees for equality by comparing equality of root nodes.

      Note: marked as abstract to ensure all implementation classes define it properly and not rely on definition from `Object`.

      Specified by:
        `equals` in class `JsonNode`

    - #### _childrenEqual

          protected boolean _childrenEqual(ArrayNode other)

      Since:
        2.3

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `BaseJsonNode`

    - #### toString

          public java.lang.String toString()

      Description copied from class: `JsonNode`
      Method that will produce developer-readable representation of the node; which may or may not be as valid JSON. If you want valid JSON output (or output formatted using one of other Jackson supported data formats) make sure to use `ObjectMapper` or `ObjectWriter` to serialize an instance, for example:

             String json = objectMapper.writeValueAsString(rootNode);

      Note: method defined as abstract to ensure all implementation classes explicitly implement method, instead of relying on `Object.toString()` definition.

      Specified by:
        `toString` in class `JsonNode`

    - #### _add

          protected ArrayNode _add(JsonNode node)

    - #### _insert

          protected ArrayNode _insert(int index,
                          JsonNode node)